import { Observable, FetchResult, Subscriber, Subscription } from './types';
export default abstract class AbstractObservable implements Observable {
    private subscribers;
    private terminated;
    constructor();
    protected abstract start(): any;
    protected abstract stop(): any;
    subscribe(nextOrSubscriber: Subscriber<FetchResult> | ((result: FetchResult) => void), error?: (error: any) => void, complete?: () => void): Subscription;
    protected onNext(data: FetchResult): void;
    protected onError(error: any): void;
    protected onComplete(): void;
    private terminate;
}
