"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var singleRequestLink_1 = require("./singleRequestLink");
var apollo_fetch_1 = require("apollo-fetch");
function createHttpLink(uri) {
    if (uri === void 0) { uri = '/graphql'; }
    var fetch = apollo_fetch_1.createApolloFetch({ uri: uri });
    var link = new singleRequestLink_1.default({ fetch: fetch });
    link.use = function (middlewares) {
        fetch.use(middlewares);
        return link;
    };
    link.useAfter = function (afterwares) {
        fetch.useAfter(afterwares);
        return link;
    };
    return link;
}
exports.createHttpLink = createHttpLink;
//# sourceMappingURL=httpLink.js.map