"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operationToPromise = function (link) {
    return function (operation) {
        var observable = link.request(operation);
        return new Promise(function (resolve, reject) {
            observable.subscribe({
                next: resolve,
                error: reject,
            });
        });
    };
};
function linkToNetworkInterface(link) {
    var request = operationToPromise(link);
    return {
        query: request,
    };
}
exports.linkToNetworkInterface = linkToNetworkInterface;
function linkPromiseWrapper(link) {
    return {
        request: operationToPromise(link),
    };
}
exports.linkPromiseWrapper = linkPromiseWrapper;
//# sourceMappingURL=link-as-promise.js.map