"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var oneTimeObservable_1 = require("./oneTimeObservable");
var linkUtils_1 = require("./linkUtils");
var apollo_fetch_1 = require("apollo-fetch");
var printer_1 = require("graphql/language/printer");
var SingleRequestLink = (function () {
    function SingleRequestLink(fetchParams) {
        this._fetch = fetchParams && fetchParams.fetch || apollo_fetch_1.createApolloFetch({ uri: fetchParams && fetchParams.uri });
    }
    SingleRequestLink.prototype.request = function (operation) {
        linkUtils_1.validateOperation(operation);
        var request = __assign({}, operation, { query: printer_1.print(operation.query) });
        return new oneTimeObservable_1.default(this._fetch(request));
    };
    return SingleRequestLink;
}());
exports.default = SingleRequestLink;
//# sourceMappingURL=singleRequestLink.js.map